import { 
  select, 
  json, 
  zoom,
  forceSimulation, 
  forceLink,
  forceManyBody, 
  forceCenter,
  drag,
  event,
  continuous,
  scaleLinear
} from 'd3';

export const menuFactory = (x, y, menuItems, data, svgId) => {
    d3.select('.contextMenu').remove();

    // Draw the menu
    d3.select(svgId)
        .append('g').attr('class', 'contextMenu')
        .selectAll('tmp')
        .data(menuItems).enter()
        .append('g').attr('class', 'menuEntry')
        .style({'cursor': 'pointer'});

    // Draw menu entries
    d3.selectAll('.menuEntry')
        .append('rect')
        .attr('x', x)
        .attr('y', (d, i) => { return y + (i * 30); })
        .attr('rx', 2)
        .attr('width', 150)
        .attr('height', 30)
        .on('click', (d) => { d.action(data) });

    d3.selectAll('.menuEntry')
        .append('text')
        .text((d) => { return d.title; })
        .attr('x', x)
        .attr('y', (d, i) => { return y + (i * 30); })
        .attr('dy', 20)
        .attr('dx', 45)
        .on('click', (d) => { d.action(data) });

    // Other interactions
    d3.select('body')
        .on('click', () => {
            d3.select('.contextMenu').remove();
        });
}

export const createContextMenu = (d, menuItems, width, height, svgId) => {  	
    menuFactory(d.x, d.y, menuItems, d, svgId);   
  	d3.event.preventDefault();
}